/*
 * Smart GWT (GWT for SmartClient)
 * Copyright 2008 and beyond, Isomorphic Software, Inc.
 *
 * Smart GWT is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License version 3
 * as published by the Free Software Foundation.  Smart GWT is also
 * available under typical commercial license terms - see
 * http://smartclient.com/license
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 */
/* sgwtgen */
 
package com.smartgwt.client.ai;


import com.smartgwt.client.event.*;
import com.smartgwt.client.core.*;
import com.smartgwt.client.types.*;
import com.smartgwt.client.data.*;
import com.smartgwt.client.data.Record;
import com.smartgwt.client.data.events.*;
import com.smartgwt.client.browser.window.*;
import com.smartgwt.client.rpc.*;
import com.smartgwt.client.ai.*;
import com.smartgwt.client.callbacks.*;
import com.smartgwt.client.tools.*;
import com.smartgwt.client.bean.*;
import com.smartgwt.client.widgets.*;
import com.smartgwt.client.widgets.ai.*;
import com.smartgwt.client.widgets.events.*;
import com.smartgwt.client.widgets.form.*;
import com.smartgwt.client.widgets.form.validator.*;
import com.smartgwt.client.widgets.form.fields.*;
import com.smartgwt.client.widgets.tile.*;
import com.smartgwt.client.widgets.tile.events.*;
import com.smartgwt.client.widgets.grid.*;
import com.smartgwt.client.widgets.grid.events.*;
import com.smartgwt.client.widgets.chart.*;
import com.smartgwt.client.widgets.layout.*;
import com.smartgwt.client.widgets.layout.events.*;
import com.smartgwt.client.widgets.menu.*;
import com.smartgwt.client.widgets.tour.*;
import com.smartgwt.client.widgets.notify.*;
import com.smartgwt.client.widgets.rte.*;
import com.smartgwt.client.widgets.rte.events.*;
import com.smartgwt.client.widgets.ace.*;
import com.smartgwt.client.widgets.ace.events.*;
import com.smartgwt.client.widgets.tab.*;
import com.smartgwt.client.widgets.toolbar.*;
import com.smartgwt.client.widgets.tree.*;
import com.smartgwt.client.widgets.tree.events.*;
import com.smartgwt.client.widgets.tableview.*;
import com.smartgwt.client.widgets.viewer.*;
import com.smartgwt.client.widgets.calendar.*;
import com.smartgwt.client.widgets.calendar.events.*;
import com.smartgwt.client.widgets.cube.*;
import com.smartgwt.client.widgets.notify.*;
import com.smartgwt.client.widgets.drawing.*;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import com.google.gwt.event.shared.*;
import com.google.gwt.dom.client.Element;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.core.client.JavaScriptObject;

import com.smartgwt.client.util.*;
import com.smartgwt.client.util.events.*;
import com.smartgwt.client.util.workflow.*;
import com.smartgwt.client.util.workflow.Process; // required to override java.lang.Process
import com.smartgwt.client.util.tour.*;


/**
 * 
 */
@BeanFactory.FrameworkClass
public class DataBoundAIRequest extends AsyncDataBoundOperationParams {

    public static DataBoundAIRequest getOrCreateRef(JavaScriptObject jsObj) {
        if (jsObj == null) return null;

        final RefDataClass existingObj = RefDataClass.getRef(jsObj);

        if (existingObj instanceof DataBoundAIRequest) {
            existingObj.setJsObj(jsObj);
            return (DataBoundAIRequest)existingObj;
        } else

        {
            return new DataBoundAIRequest(jsObj);
        }
    }
        


    public DataBoundAIRequest(){
        
    }

    public DataBoundAIRequest(JavaScriptObject jsObj){
        
        setJavaScriptObject(jsObj);
    }


    // ********************* Properties / Attributes ***********************

    /**
     * Optional list of field names to exclude. This is a deny list.
     *
     * @param excludeFieldNames New excludeFieldNames value. Default value is null
     * @return {@link com.smartgwt.client.ai.DataBoundAIRequest DataBoundAIRequest} instance, for chaining setter calls
     * @see com.smartgwt.client.docs.FieldName FieldName 
     */
    public DataBoundAIRequest setExcludeFieldNames(String... excludeFieldNames) {
        return (DataBoundAIRequest)setAttribute("excludeFieldNames", excludeFieldNames);
    }

    /**
     * Optional list of field names to exclude. This is a deny list.
     *
     * @return Current excludeFieldNames value. Default value is null
     * @see com.smartgwt.client.docs.FieldName FieldName 
     */
    public String[] getExcludeFieldNames()  {
        return com.smartgwt.client.util.ConvertTo.arrayOfString(getAttributeAsJavaScriptObject("excludeFieldNames"));
    }
    

    /**
     * The maximum number of retries for any one particular request to AI. <p> Note that multiple AI requests may be involved
     * in processing the data-bound AI request. This limit is the maximum number of retries of any one request. For example, if
     * there are 2 requests made to AI, then each one would be submitted at most <code>1 + maxRetries</code> number of times
     * for up to <code>2 * (1 + maxRetries)</code> total requests. <p> If unset, then {@link
     * com.smartgwt.client.ai.AI#defaultMaxRetries defaultMaxRetries} will be used.
     *
     * @param maxRetries New maxRetries value. Default value is null
     * @return {@link com.smartgwt.client.ai.DataBoundAIRequest DataBoundAIRequest} instance, for chaining setter calls
     */
    public DataBoundAIRequest setMaxRetries(Integer maxRetries) {
        return (DataBoundAIRequest)setAttribute("maxRetries", maxRetries);
    }

    /**
     * The maximum number of retries for any one particular request to AI. <p> Note that multiple AI requests may be involved
     * in processing the data-bound AI request. This limit is the maximum number of retries of any one request. For example, if
     * there are 2 requests made to AI, then each one would be submitted at most <code>1 + maxRetries</code> number of times
     * for up to <code>2 * (1 + maxRetries)</code> total requests. <p> If unset, then {@link
     * com.smartgwt.client.ai.AI#defaultMaxRetries defaultMaxRetries} will be used.
     *
     * @return Current maxRetries value. Default value is null
     */
    public Integer getMaxRetries()  {
        return getAttributeAsInt("maxRetries");
    }
    

    // ********************* Methods ***********************

    // ********************* Static Methods ***********************

    // ***********************************************************

}
